<?php

namespace XF\Search;

class MetadataStructure
{
	/**
	 * @var string
	 */
	const INT = 'int';

	/**
	 * @var string
	 */
	const FLOAT = 'float';

	/**
	 * @var string
	 */
	const STR = 'str';

	/**
	 * @var string
	 */
	const KEYWORD = 'keyword';

	/**
	 * @var string
	 */
	const BOOL = 'bool';

	/**
	 * @var array<string, array<string, mixed>>
	 */
	protected $fields;

	/**
	 * @param array<string, array<string, mixed>> $fields
	 */
	public function __construct(array $fields = [])
	{
		$this->fields = $fields;
	}

	/**
	 * @param string $name
	 * @param string $type
	 * @param array<string, mixed> $config
	 */
	public function addField($name, $type, array $config = [])
	{
		$config['type'] = $type;
		$this->fields[$name] = $config;
	}

	/**
	 * @return array<string, array<string, mixed>>
	 */
	public function getFields()
	{
		return $this->fields;
	}
}